module constants_module
  implicit none
  private
  public :: DP,SP
  public :: INT,LINT
  public :: Z0,Z1,ZI,PI
  public :: CHARLEN, SW_ON, SW_OFF
  public :: ZERO, ONE, TWO

  integer,     parameter :: QP  = SELECTED_REAL_KIND(33)
  integer,     parameter :: DP  = SELECTED_REAL_KIND(15)
  integer,     parameter :: SP  = SELECTED_REAL_KIND(6)
  integer,     parameter ::  INT = SELECTED_INT_KIND(9)
  integer,     parameter :: LINT = SELECTED_INT_KIND(18)
  complex(DP), parameter :: Z0 = (0.0_DP,0.0_DP)
  complex(DP), parameter :: Z1 = (1.0_DP,0.0_DP)
  complex(DP), parameter :: ZI = (0.0_DP,1.0_DP)
  real(DP),    parameter :: PI = 4 * ATAN(1.0_DP)
  real(DP),    parameter :: ZERO = 0.0_DP
  real(DP),    parameter ::  ONE = 1.0_DP
  real(DP),    parameter ::  TWO = 2.0_DP

  integer, parameter :: CHARLEN=256  ! max characger length, used for file names.
  integer, parameter :: SW_ON  = 1   ! switch on
  integer, parameter :: SW_OFF = 0   ! switch off
 
end module
