static __global__ void 
#ifdef _CLOVER
cumult_wd_kernel(cuhqfield *yo,cuhqfield *yde,cuhgvfield *ue,cuhgvfield *uo,int *ieo,cuhclvfield *fclinve){
#else
cumult_wd_kernel(cuhqfield *yo,cuhqfield *yde,cuhgvfield *ue,cuhgvfield *uo,int *ieo){
#endif
/************************************************************************
*$Id: cumult_wd.h,v 1.12 2011/10/23 11:01:55 ishikawa Exp $
* Multiply odd->even/even->odd hopping matrix : yde =  Meo yo
*
*      yo : odd/even site fermion (ieo=0/1) (input)
*     yde : even/odd site fermion (ieo=0/1) (output)
*      ue : even/odd site gauge link (ieo=0/1)
*      uo : odd/even site gauge link (ieo=0/1)
*     ieo : operate even/odd site
*           ieo=0 for even site link
*           ieo=1 for odd  site link
* fclinve : even/odd site inverse clover term (ieo=0/1)
* fclinvo : odd/even site inverse clover term (ieo=0/1)
*
******************************************************************************/
  __align__(16) float ytr[CLSP],yti[CLSP];
  int ithd = threadIdx.x;
  int iblk = blockIdx.x;

//
// isite : Lattice site index
// jsite : Lattice site index
//         in (sub-lattice, block-lattice) representation.
#define  thd_t  (ithd % _NBT)
#define  thd_z  (ithd /(_NBT) % _NBZ)
#define  thd_y  (ithd /(_NBT*_NBZ) % _NBY)
#define  thd_x  (ithd /(_NBT*_NBZ*_NBY) % _NBX)
#define  blk_t  (iblk % _NGT)
#define  blk_z  (iblk /(_NGT) % _NGZ)
#define  blk_y  (iblk /(_NGT*_NGZ) % _NGY)
#define  blk_x  (iblk /(_NGT*_NGZ*_NGY) % _NGX)

/*
  int itb    = thd_t + blk_t*_NBT;
  int iz     = thd_z + blk_z*_NBZ;
  int iy     = thd_y + blk_y*_NBY;
  int ix     = thd_x + blk_x*_NBX;
  int ieoxyz = ((*ieo)+(iz+1)+(iy+1)+(ix+1))%2;
  int it     = (itb+1-ieoxyz)*2+ieoxyz-1;
*/


  ytr[0]=0.0f;
  ytr[1]=0.0f;
  ytr[2]=0.0f;
  ytr[3]=0.0f;
  ytr[4]=0.0f;
  ytr[5]=0.0f;
  yti[0]=0.0f;
  yti[1]=0.0f;
  yti[2]=0.0f;
  yti[3]=0.0f;
  yti[4]=0.0f;
  yti[5]=0.0f;

  { 
    int itb    = thd_t + blk_t*_NBT;
    int iz     = thd_z + blk_z*_NBZ;
    int iy     = thd_y + blk_y*_NBY;
    int ix     = thd_x + blk_x*_NBX;
    int ieoxyz = ((*ieo)+(iz+1)+(iy+1)+(ix+1))%2;
    int it     = (itb+1-ieoxyz)*2+ieoxyz-1;
    int itp = (((it+1+NT)%NT)+1)/2-ieoxyz;
    int ithd_t_up = ithd + (itp % _NBT) - thd_t;
    int iblk_t_up = iblk + (itp / _NBT) - blk_t;
    __align__(16) float4 yri[CSH];
#ifdef _YTEXTURE_
    yri[1] = __loady_tex(tex_yori,ithd_t_up,1,iblk_t_up);
    yri[2] = __loady_tex(tex_yori,ithd_t_up,2,iblk_t_up);
    yri[4] = __loady_tex(tex_yori,ithd_t_up,4,iblk_t_up);
    yri[5] = __loady_tex(tex_yori,ithd_t_up,5,iblk_t_up);
#else
    yri[1] = (*yo).b[iblk_t_up].yri[1].c[ithd_t_up];
    yri[2] = (*yo).b[iblk_t_up].yri[2].c[ithd_t_up];
    yri[4] = (*yo).b[iblk_t_up].yri[4].c[ithd_t_up];
    yri[5] = (*yo).b[iblk_t_up].yri[5].c[ithd_t_up];
#endif
    __align__(16) float4 uri[COL];
#ifdef _UTEXTURE_
    uri[0] = __loadu_tex(tex_ueri,ithd,0,3,iblk);
    uri[1] = __loadu_tex(tex_ueri,ithd,1,3,iblk);
    uri[2] = __loadu_tex(tex_ueri,ithd,2,3,iblk);
#else
    uri[0] = (*ue).b[iblk].v[3].uri[0].c[ithd];
    uri[1] = (*ue).b[iblk].v[3].uri[1].c[ithd];
    uri[2] = (*ue).b[iblk].v[3].uri[2].c[ithd];
#endif
    cu_mult_forw_t(uri,yri,ytr,yti);
  }

  { 
    int itb    = thd_t + blk_t*_NBT;
    int iz     = thd_z + blk_z*_NBZ;
    int iy     = thd_y + blk_y*_NBY;
    int ix     = thd_x + blk_x*_NBX;
    int ieoxyz = ((*ieo)+(iz+1)+(iy+1)+(ix+1))%2;
    int it     = (itb+1-ieoxyz)*2+ieoxyz-1;
    int itd=(((it-1+NT)%NT)+1)/2-ieoxyz;
    int ithd_t_dn = ithd + (itd % _NBT) - thd_t;
    int iblk_t_dn = iblk + (itd / _NBT) - blk_t;
    __align__(16) float4 yri[CSH];
#ifdef _YTEXTURE_
    yri[0] = __loady_tex(tex_yori,ithd_t_dn,0,iblk_t_dn);
    yri[1] = __loady_tex(tex_yori,ithd_t_dn,1,iblk_t_dn);
    yri[3] = __loady_tex(tex_yori,ithd_t_dn,3,iblk_t_dn);
    yri[4] = __loady_tex(tex_yori,ithd_t_dn,4,iblk_t_dn);
#else
    yri[0] = (*yo).b[iblk_t_dn].yri[0].c[ithd_t_dn];
    yri[1] = (*yo).b[iblk_t_dn].yri[1].c[ithd_t_dn];
    yri[3] = (*yo).b[iblk_t_dn].yri[3].c[ithd_t_dn];
    yri[4] = (*yo).b[iblk_t_dn].yri[4].c[ithd_t_dn];
#endif
    __align__(16) float4 uri[COL];
#ifdef _UTEXTURE_
    uri[0] = __loadu_tex(tex_uori,ithd_t_dn,0,3,iblk_t_dn);
    uri[1] = __loadu_tex(tex_uori,ithd_t_dn,1,3,iblk_t_dn);
    uri[2] = __loadu_tex(tex_uori,ithd_t_dn,2,3,iblk_t_dn);
#else
    uri[0] = (*uo).b[iblk_t_dn].v[3].uri[0].c[ithd_t_dn];
    uri[1] = (*uo).b[iblk_t_dn].v[3].uri[1].c[ithd_t_dn];
    uri[2] = (*uo).b[iblk_t_dn].v[3].uri[2].c[ithd_t_dn];
#endif
    cu_mult_back_t(uri,yri,ytr,yti);
  }

  { 
    int iz      = thd_z + blk_z*_NBZ;
    int ithd_z_up = ithd + ((((iz+1+NZ) % NZ) % _NBZ) - thd_z)*_NBT;
    int iblk_z_up = iblk + ((((iz+1+NZ) % NZ) / _NBZ) - blk_z)*_NGT;
    __align__(16) float4 yri[CSH];
#ifdef _YTEXTURE_
    yri[0] = __loady_tex(tex_yori,ithd_z_up,0,iblk_z_up);
    yri[1] = __loady_tex(tex_yori,ithd_z_up,1,iblk_z_up);
    yri[2] = __loady_tex(tex_yori,ithd_z_up,2,iblk_z_up);
    yri[3] = __loady_tex(tex_yori,ithd_z_up,3,iblk_z_up);
    yri[4] = __loady_tex(tex_yori,ithd_z_up,4,iblk_z_up);
    yri[5] = __loady_tex(tex_yori,ithd_z_up,5,iblk_z_up);
#else
    yri[0] = (*yo).b[iblk_z_up].yri[0].c[ithd_z_up];
    yri[1] = (*yo).b[iblk_z_up].yri[1].c[ithd_z_up];
    yri[2] = (*yo).b[iblk_z_up].yri[2].c[ithd_z_up];
    yri[3] = (*yo).b[iblk_z_up].yri[3].c[ithd_z_up];
    yri[4] = (*yo).b[iblk_z_up].yri[4].c[ithd_z_up];
    yri[5] = (*yo).b[iblk_z_up].yri[5].c[ithd_z_up];
#endif
    __align__(16) float4 uri[COL];
#ifdef _UTEXTURE_
    uri[0] = __loadu_tex(tex_ueri,ithd,0,2,iblk);
    uri[1] = __loadu_tex(tex_ueri,ithd,1,2,iblk);
    uri[2] = __loadu_tex(tex_ueri,ithd,2,2,iblk);
#else
    uri[0] = (*ue).b[iblk].v[2].uri[0].c[ithd];
    uri[1] = (*ue).b[iblk].v[2].uri[1].c[ithd];
    uri[2] = (*ue).b[iblk].v[2].uri[2].c[ithd];
#endif
    cu_mult_forw_z(uri,yri,ytr,yti);
  }

  { 
    int iz     = thd_z + blk_z*_NBZ;
    int ithd_z_dn = ithd + ((((iz-1+NZ) % NZ) % _NBZ) - thd_z)*_NBT;
    int iblk_z_dn = iblk + ((((iz-1+NZ) % NZ) / _NBZ) - blk_z)*_NGT;
    __align__(16) float4 yri[CSH];
#ifdef _YTEXTURE_
    yri[0] = __loady_tex(tex_yori,ithd_z_dn,0,iblk_z_dn);
    yri[1] = __loady_tex(tex_yori,ithd_z_dn,1,iblk_z_dn);
    yri[2] = __loady_tex(tex_yori,ithd_z_dn,2,iblk_z_dn);
    yri[3] = __loady_tex(tex_yori,ithd_z_dn,3,iblk_z_dn);
    yri[4] = __loady_tex(tex_yori,ithd_z_dn,4,iblk_z_dn);
    yri[5] = __loady_tex(tex_yori,ithd_z_dn,5,iblk_z_dn);
#else
    yri[0] = (*yo).b[iblk_z_dn].yri[0].c[ithd_z_dn];
    yri[1] = (*yo).b[iblk_z_dn].yri[1].c[ithd_z_dn];
    yri[2] = (*yo).b[iblk_z_dn].yri[2].c[ithd_z_dn];
    yri[3] = (*yo).b[iblk_z_dn].yri[3].c[ithd_z_dn];
    yri[4] = (*yo).b[iblk_z_dn].yri[4].c[ithd_z_dn];
    yri[5] = (*yo).b[iblk_z_dn].yri[5].c[ithd_z_dn];
#endif
    __align__(16) float4 uri[COL];
#ifdef _UTEXTURE_
    uri[0] = __loadu_tex(tex_uori,ithd_z_dn,0,2,iblk_z_dn);
    uri[1] = __loadu_tex(tex_uori,ithd_z_dn,1,2,iblk_z_dn);
    uri[2] = __loadu_tex(tex_uori,ithd_z_dn,2,2,iblk_z_dn);
#else
    uri[0] = (*uo).b[iblk_z_dn].v[2].uri[0].c[ithd_z_dn];
    uri[1] = (*uo).b[iblk_z_dn].v[2].uri[1].c[ithd_z_dn];
    uri[2] = (*uo).b[iblk_z_dn].v[2].uri[2].c[ithd_z_dn];
#endif
    cu_mult_back_z(uri,yri,ytr,yti);
  }

  { 
    int iy     = thd_y + blk_y*_NBY;
    int ithd_y_up = ithd + ((((iy+1+NY) % NY) % _NBY) - thd_y)*(_NBT*_NBZ);
    int iblk_y_up = iblk + ((((iy+1+NY) % NY) / _NBY) - blk_y)*(_NGT*_NGZ);
    __align__(16) float4 yri[CSH];
#ifdef _YTEXTURE_
    yri[0] = __loady_tex(tex_yori,ithd_y_up,0,iblk_y_up);
    yri[1] = __loady_tex(tex_yori,ithd_y_up,1,iblk_y_up);
    yri[2] = __loady_tex(tex_yori,ithd_y_up,2,iblk_y_up);
    yri[3] = __loady_tex(tex_yori,ithd_y_up,3,iblk_y_up);
    yri[4] = __loady_tex(tex_yori,ithd_y_up,4,iblk_y_up);
    yri[5] = __loady_tex(tex_yori,ithd_y_up,5,iblk_y_up);
#else
    yri[0] = (*yo).b[iblk_y_up].yri[0].c[ithd_y_up];
    yri[1] = (*yo).b[iblk_y_up].yri[1].c[ithd_y_up];
    yri[2] = (*yo).b[iblk_y_up].yri[2].c[ithd_y_up];
    yri[3] = (*yo).b[iblk_y_up].yri[3].c[ithd_y_up];
    yri[4] = (*yo).b[iblk_y_up].yri[4].c[ithd_y_up];
    yri[5] = (*yo).b[iblk_y_up].yri[5].c[ithd_y_up];
#endif
    __align__(16) float4 uri[COL];
#ifdef _UTEXTURE_
    uri[0] = __loadu_tex(tex_ueri,ithd,0,1,iblk);
    uri[1] = __loadu_tex(tex_ueri,ithd,1,1,iblk);
    uri[2] = __loadu_tex(tex_ueri,ithd,2,1,iblk);
#else
    uri[0] = (*ue).b[iblk].v[1].uri[0].c[ithd];
    uri[1] = (*ue).b[iblk].v[1].uri[1].c[ithd];
    uri[2] = (*ue).b[iblk].v[1].uri[2].c[ithd];
#endif
    cu_mult_forw_y(uri,yri,ytr,yti);
  }

  { 
    int iy     = thd_y + blk_y*_NBY;
    int ithd_y_dn = ithd + ((((iy-1+NY) % NY) % _NBY) - thd_y)*(_NBT*_NBZ);
    int iblk_y_dn = iblk + ((((iy-1+NY) % NY) / _NBY) - blk_y)*(_NGT*_NGZ);
    __align__(16) float4 yri[CSH];
#ifdef _YTEXTURE_
    yri[0] = __loady_tex(tex_yori,ithd_y_dn,0,iblk_y_dn);
    yri[1] = __loady_tex(tex_yori,ithd_y_dn,1,iblk_y_dn);
    yri[2] = __loady_tex(tex_yori,ithd_y_dn,2,iblk_y_dn);
    yri[3] = __loady_tex(tex_yori,ithd_y_dn,3,iblk_y_dn);
    yri[4] = __loady_tex(tex_yori,ithd_y_dn,4,iblk_y_dn);
    yri[5] = __loady_tex(tex_yori,ithd_y_dn,5,iblk_y_dn);
#else
    yri[0] = (*yo).b[iblk_y_dn].yri[0].c[ithd_y_dn];
    yri[1] = (*yo).b[iblk_y_dn].yri[1].c[ithd_y_dn];
    yri[2] = (*yo).b[iblk_y_dn].yri[2].c[ithd_y_dn];
    yri[3] = (*yo).b[iblk_y_dn].yri[3].c[ithd_y_dn];
    yri[4] = (*yo).b[iblk_y_dn].yri[4].c[ithd_y_dn];
    yri[5] = (*yo).b[iblk_y_dn].yri[5].c[ithd_y_dn];
#endif
    __align__(16) float4 uri[COL];
#ifdef _UTEXTURE_
    uri[0] = __loadu_tex(tex_uori,ithd_y_dn,0,1,iblk_y_dn);
    uri[1] = __loadu_tex(tex_uori,ithd_y_dn,1,1,iblk_y_dn);
    uri[2] = __loadu_tex(tex_uori,ithd_y_dn,2,1,iblk_y_dn);
#else
    uri[0] = (*uo).b[iblk_y_dn].v[1].uri[0].c[ithd_y_dn];
    uri[1] = (*uo).b[iblk_y_dn].v[1].uri[1].c[ithd_y_dn];
    uri[2] = (*uo).b[iblk_y_dn].v[1].uri[2].c[ithd_y_dn];
#endif
    cu_mult_back_y(uri,yri,ytr,yti);
  }

  { 
    int ix     = thd_x + blk_x*_NBX;
    int ithd_x_up = ithd + ((((ix+1+NX) % NX) % _NBX) - thd_x)*(_NBT*_NBZ*_NBY);
    int iblk_x_up = iblk + ((((ix+1+NX) % NX) / _NBX) - blk_x)*(_NGT*_NGZ*_NGY);
    __align__(16) float4 yri[CSH];
#ifdef _YTEXTURE_
    yri[0] = __loady_tex(tex_yori,ithd_x_up,0,iblk_x_up);
    yri[1] = __loady_tex(tex_yori,ithd_x_up,1,iblk_x_up);
    yri[2] = __loady_tex(tex_yori,ithd_x_up,2,iblk_x_up);
    yri[3] = __loady_tex(tex_yori,ithd_x_up,3,iblk_x_up);
    yri[4] = __loady_tex(tex_yori,ithd_x_up,4,iblk_x_up);
    yri[5] = __loady_tex(tex_yori,ithd_x_up,5,iblk_x_up);
#else
    yri[0] = (*yo).b[iblk_x_up].yri[0].c[ithd_x_up];
    yri[1] = (*yo).b[iblk_x_up].yri[1].c[ithd_x_up];
    yri[2] = (*yo).b[iblk_x_up].yri[2].c[ithd_x_up];
    yri[3] = (*yo).b[iblk_x_up].yri[3].c[ithd_x_up];
    yri[4] = (*yo).b[iblk_x_up].yri[4].c[ithd_x_up];
    yri[5] = (*yo).b[iblk_x_up].yri[5].c[ithd_x_up];
#endif
    __align__(16) float4 uri[COL];
#ifdef _UTEXTURE_
    uri[0] = __loadu_tex(tex_ueri,ithd,0,0,iblk);
    uri[1] = __loadu_tex(tex_ueri,ithd,1,0,iblk);
    uri[2] = __loadu_tex(tex_ueri,ithd,2,0,iblk);
#else
    uri[0] = (*ue).b[iblk].v[0].uri[0].c[ithd];
    uri[1] = (*ue).b[iblk].v[0].uri[1].c[ithd];
    uri[2] = (*ue).b[iblk].v[0].uri[2].c[ithd];
#endif
    cu_mult_forw_x(uri,yri,ytr,yti);
  }

  { 
    int ix     = thd_x + blk_x*_NBX;
    int ithd_x_dn = ithd + ((((ix-1+NX) % NX) % _NBX) - thd_x)*(_NBT*_NBZ*_NBY);
    int iblk_x_dn = iblk + ((((ix-1+NX) % NX) / _NBX) - blk_x)*(_NGT*_NGZ*_NGY);
    __align__(16) float4 yri[CSH];
#ifdef _YTEXTURE_
    yri[0] = __loady_tex(tex_yori,ithd_x_dn,0,iblk_x_dn);
    yri[1] = __loady_tex(tex_yori,ithd_x_dn,1,iblk_x_dn);
    yri[2] = __loady_tex(tex_yori,ithd_x_dn,2,iblk_x_dn);
    yri[3] = __loady_tex(tex_yori,ithd_x_dn,3,iblk_x_dn);
    yri[4] = __loady_tex(tex_yori,ithd_x_dn,4,iblk_x_dn);
    yri[5] = __loady_tex(tex_yori,ithd_x_dn,5,iblk_x_dn);
#else
    yri[0] = (*yo).b[iblk_x_dn].yri[0].c[ithd_x_dn];
    yri[1] = (*yo).b[iblk_x_dn].yri[1].c[ithd_x_dn];
    yri[2] = (*yo).b[iblk_x_dn].yri[2].c[ithd_x_dn];
    yri[3] = (*yo).b[iblk_x_dn].yri[3].c[ithd_x_dn];
    yri[4] = (*yo).b[iblk_x_dn].yri[4].c[ithd_x_dn];
    yri[5] = (*yo).b[iblk_x_dn].yri[5].c[ithd_x_dn];
#endif
    __align__(16) float4 uri[COL];
#ifdef _UTEXTURE_
    uri[0] = __loadu_tex(tex_uori,ithd_x_dn,0,0,iblk_x_dn);
    uri[1] = __loadu_tex(tex_uori,ithd_x_dn,1,0,iblk_x_dn);
    uri[2] = __loadu_tex(tex_uori,ithd_x_dn,2,0,iblk_x_dn);
#else
    uri[0] = (*uo).b[iblk_x_dn].v[0].uri[0].c[ithd_x_dn];
    uri[1] = (*uo).b[iblk_x_dn].v[0].uri[1].c[ithd_x_dn];
    uri[2] = (*uo).b[iblk_x_dn].v[0].uri[2].c[ithd_x_dn];
#endif
    cu_mult_back_x(uri,yri,ytr,yti);
  }

#ifdef _CLOVER
  cu_mult_fclinv_kernel2(&(*fclinve).b[iblk],&ithd,ytr,yti);
#endif

#ifdef _SF
  {
  int itb    = thd_t + blk_t*_NBT;
  int iz     = thd_z + blk_z*_NBZ;
  int iy     = thd_y + blk_y*_NBY;
  int ix     = thd_x + blk_x*_NBX;
  int ieoxyz = ((*ieo)+(iz+1)+(iy+1)+(ix+1))%2;
  float flag = (float)(1-ieoxyz*((_NTH - itb)/_NTH));
  ytr[ 0] = ytr[ 0] * flag;
  ytr[ 1] = ytr[ 1] * flag;
  ytr[ 2] = ytr[ 2] * flag;
  ytr[ 3] = ytr[ 3] * flag;
  ytr[ 4] = ytr[ 4] * flag;
  ytr[ 5] = ytr[ 5] * flag;
  ytr[ 6] = ytr[ 6] * flag;
  ytr[ 7] = ytr[ 7] * flag;
  ytr[ 8] = ytr[ 8] * flag;
  ytr[ 9] = ytr[ 9] * flag;
  ytr[10] = ytr[10] * flag;
  ytr[11] = ytr[11] * flag;
  yti[ 0] = yti[ 0] * flag;
  yti[ 1] = yti[ 1] * flag;
  yti[ 2] = yti[ 2] * flag;
  yti[ 3] = yti[ 3] * flag;
  yti[ 4] = yti[ 4] * flag;
  yti[ 5] = yti[ 5] * flag;
  yti[ 6] = yti[ 6] * flag;
  yti[ 7] = yti[ 7] * flag;
  yti[ 8] = yti[ 8] * flag;
  yti[ 9] = yti[ 9] * flag;
  yti[10] = yti[10] * flag;
  yti[11] = yti[11] * flag;
  }
#endif

  (*yde).b[iblk].yri[0].c[ithd] = *(float4 *)(ytr+0);
  (*yde).b[iblk].yri[1].c[ithd] = *(float4 *)(ytr+4);
  (*yde).b[iblk].yri[2].c[ithd] = *(float4 *)(ytr+8);
  (*yde).b[iblk].yri[3].c[ithd] = *(float4 *)(yti+0);
  (*yde).b[iblk].yri[4].c[ithd] = *(float4 *)(yti+4);
  (*yde).b[iblk].yri[5].c[ithd] = *(float4 *)(yti+8);

}

extern "C" static void 
#ifdef _CLOVER
cumult_wd(cuhqfield *yo,cuhqfield *yde,cuhgvfield *ue,cuhgvfield *uo,int *ieo,cuhclvfield *fclinve)
#else
cumult_wd(cuhqfield *yo,cuhqfield *yde,cuhgvfield *ue,cuhgvfield *uo,int *ieo)
#endif
{
#ifdef _DEBUG_
  cutStartTimer(multtime);
#endif

#ifdef _YTEXTURE_
  CUDA_SAFE_CALL(cudaBindTexture(0,tex_yori,yo,sizeof(cuhqfield)));
#endif
#ifdef _UTEXTURE_
  CUDA_SAFE_CALL(cudaBindTexture(0,tex_ueri,ue,sizeof(cuhgvfield)));
  CUDA_SAFE_CALL(cudaBindTexture(0,tex_uori,uo,sizeof(cuhgvfield)));
#endif

#ifdef _CLOVER
  cumult_wd_kernel<<<BLOCKS,THREADS>>>(yo,yde,ue,uo,ieo,fclinve);
#else
  cumult_wd_kernel<<<BLOCKS,THREADS>>>(yo,yde,ue,uo,ieo);
#endif
  CUT_CHECK_ERROR("cumult_wd kernel execution faild");

#ifdef _YTEXTURE_
  CUDA_SAFE_CALL(cudaUnbindTexture(tex_yori));
#endif
#ifdef _UTEXTURE_
  CUDA_SAFE_CALL(cudaUnbindTexture(tex_ueri));
  CUDA_SAFE_CALL(cudaUnbindTexture(tex_uori));
#endif

  flop_mult_count += MULT_WD;
  _multiter_ += 1;
#ifdef _DEBUG_
  cutStopTimer(multtime);
#endif
}
