#!/usr/bin/perl -w
use strict;

my $in_file = "sample.F90";
my $out_file = "sample.F90.out";

open(IN, "<$in_file");
open(OUT, ">$out_file");

my $func_flg = 0;

my @subs;
my @funcs;
while (defined (my $line = <IN>)) {
    chomp($line);

    if ($line =~ /^\s*subroutine\s*([^\s]+)\s*\(/) {
        $func_flg = 0;
        unshift(@subs, $1);

    } elsif ($line =~ /^\s*function\s*([^\s]+)\s*\(/) {
        $func_flg = 1;
        unshift(@funcs, $1);

    } elsif (!$func_flg && $line =~ /^\s*end\s*subroutine/) {
        shift(@subs);

    } elsif ($func_flg && $line =~ /^\s*end\s*function/) {
        shift(@funcs);

    } elsif ($line =~ /__MY_NAME__/) {
        my $sub = ($func_flg) ? $funcs[0] : $subs[0];
        $sub = "\"". $sub ."\"";
        $line =~ s/__MY_NAME__/$sub/;
    }
    print OUT "$line\n";
}

close(IN);
close(OUT);

